sidebarNodes={"extras":[{"group":"","headers":[{"anchor":"modules","id":"Modules"},{"anchor":"mix-tasks","id":"Mix Tasks"}],"id":"api-reference","title":"API Reference"},{"group":"Introduction","headers":[{"anchor":"adding-ecto-to-an-application","id":"Adding Ecto to an application"},{"anchor":"setting-up-the-database","id":"Setting up the database"},{"anchor":"creating-the-schema","id":"Creating the schema"},{"anchor":"inserting-data","id":"Inserting data"},{"anchor":"validating-changes","id":"Validating changes"},{"anchor":"our-first-queries","id":"Our first queries"},{"anchor":"updating-records","id":"Updating records"},{"anchor":"deleting-records","id":"Deleting records"}],"id":"getting-started","title":"Getting Started"},{"group":"Introduction","headers":[],"id":"testing-with-ecto","title":"Testing with Ecto"},{"group":"How-To's","headers":[{"anchor":"aggregates","id":"Aggregates"},{"anchor":"subqueries","id":"Subqueries"}],"id":"aggregates-and-subqueries","title":"Aggregates and subqueries"},{"group":"How-To's","headers":[{"anchor":"composing-with-data-structures","id":"Composing with data structures"},{"anchor":"dependent-values","id":"Dependent values"}],"id":"composable-transactions-with-multi","title":"Composable transactions with Multi"},{"group":"How-To's","headers":[{"anchor":"put_assoc-vs-cast_assoc","id":"put_assoc vs cast_assoc"},{"anchor":"constraints-and-race-conditions","id":"Constraints and race conditions"},{"anchor":"checking-for-constraint-errors","id":"Checking for constraint errors"},{"anchor":"upserts","id":"Upserts"},{"anchor":"upserts-and-insert_all","id":"Upserts and insert_all"}],"id":"constraints-and-upserts","title":"Constraints and Upserts"},{"group":"How-To's","headers":[{"anchor":"schemas-are-mappers","id":"Schemas are mappers"},{"anchor":"schemaless-changesets","id":"Schemaless changesets"}],"id":"data-mapping-and-validation","title":"Data mapping and validation"},{"group":"How-To's","headers":[{"anchor":"focusing-on-data-structures","id":"Focusing on data structures"},{"anchor":"dynamic-fragments","id":"Dynamic fragments"},{"anchor":"building-dynamic-queries","id":"Building dynamic queries"},{"anchor":"dynamic-and-joins","id":"Dynamic and joins"}],"id":"dynamic-queries","title":"Dynamic queries"},{"group":"How-To's","headers":[{"anchor":"connection-prefixes","id":"Connection prefixes"},{"anchor":"schema-prefixes","id":"Schema prefixes"},{"anchor":"per-query-and-per-struct-prefixes","id":"Per-query and per-struct prefixes"},{"anchor":"per-from-join-prefixes","id":"Per from/join prefixes"},{"anchor":"migration-prefixes","id":"Migration prefixes"},{"anchor":"summing-up","id":"Summing up"}],"id":"multi-tenancy-with-query-prefixes","title":"Multi tenancy with query prefixes"},{"group":"How-To's","headers":[{"anchor":"todo-lists-v65131","id":"Todo lists v65131"},{"anchor":"polymorphic-todo-items","id":"Polymorphic todo items"},{"anchor":"polymorphism-with-has_many-through","id":"Polymorphism with has_many :through"},{"anchor":"polymorphism-with-many_to_many","id":"Polymorphism with many_to_many"},{"anchor":"summary","id":"Summary"}],"id":"polymorphic-associations-with-many-to-many","title":"Polymorphic associations with many to many"},{"group":"How-To's","headers":[{"anchor":"primary-and-replicas","id":"Primary and Replicas"},{"anchor":"testing-replicas","id":"Testing replicas"},{"anchor":"dynamic-repositories","id":"Dynamic repositories"}],"id":"replicas-and-dynamic-repositories","title":"Replicas and dynamic repositories"},{"group":"How-To's","headers":[{"anchor":"insert_all-update_all-and-delete_all","id":"insert_all, update_all and delete_all"}],"id":"schemaless-queries","title":"Schemaless queries"},{"group":"How-To's","headers":[],"id":"test-factories","title":"Test factories"}],"modules":[{"group":"","id":"Ecto","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"assoc/2","id":"assoc/2"},{"anchor":"assoc_loaded?/1","id":"assoc_loaded?/1"},{"anchor":"build_assoc/3","id":"build_assoc/3"},{"anchor":"embedded_dump/2","id":"embedded_dump/2"},{"anchor":"embedded_load/3","id":"embedded_load/3"},{"anchor":"get_meta/2","id":"get_meta/2"},{"anchor":"primary_key/1","id":"primary_key/1"},{"anchor":"primary_key!/1","id":"primary_key!/1"},{"anchor":"put_meta/2","id":"put_meta/2"}]}],"sections":[{"anchor":"module-repositories","id":"Repositories"},{"anchor":"module-schema","id":"Schema"},{"anchor":"module-changesets","id":"Changesets"},{"anchor":"module-query","id":"Query"},{"anchor":"module-other-topics","id":"Other topics"}],"title":"Ecto"},{"group":"","id":"Ecto.Changeset","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:action/0","id":"action/0"},{"anchor":"t:constraint/0","id":"constraint/0"},{"anchor":"t:data/0","id":"data/0"},{"anchor":"t:error/0","id":"error/0"},{"anchor":"t:t/0","id":"t/0"},{"anchor":"t:t/1","id":"t/1"},{"anchor":"t:types/0","id":"types/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"add_error/4","id":"add_error/4"},{"anchor":"apply_action/2","id":"apply_action/2"},{"anchor":"apply_action!/2","id":"apply_action!/2"},{"anchor":"apply_changes/1","id":"apply_changes/1"},{"anchor":"assoc_constraint/3","id":"assoc_constraint/3"},{"anchor":"cast/4","id":"cast/4"},{"anchor":"cast_assoc/3","id":"cast_assoc/3"},{"anchor":"cast_embed/3","id":"cast_embed/3"},{"anchor":"change/2","id":"change/2"},{"anchor":"check_constraint/3","id":"check_constraint/3"},{"anchor":"constraints/1","id":"constraints/1"},{"anchor":"delete_change/2","id":"delete_change/2"},{"anchor":"exclusion_constraint/3","id":"exclusion_constraint/3"},{"anchor":"fetch_change/2","id":"fetch_change/2"},{"anchor":"fetch_change!/2","id":"fetch_change!/2"},{"anchor":"fetch_field/2","id":"fetch_field/2"},{"anchor":"fetch_field!/2","id":"fetch_field!/2"},{"anchor":"force_change/3","id":"force_change/3"},{"anchor":"foreign_key_constraint/3","id":"foreign_key_constraint/3"},{"anchor":"get_change/3","id":"get_change/3"},{"anchor":"get_field/3","id":"get_field/3"},{"anchor":"merge/2","id":"merge/2"},{"anchor":"no_assoc_constraint/3","id":"no_assoc_constraint/3"},{"anchor":"optimistic_lock/3","id":"optimistic_lock/3"},{"anchor":"prepare_changes/2","id":"prepare_changes/2"},{"anchor":"put_assoc/4","id":"put_assoc/4"},{"anchor":"put_change/3","id":"put_change/3"},{"anchor":"put_embed/4","id":"put_embed/4"},{"anchor":"traverse_errors/2","id":"traverse_errors/2"},{"anchor":"unique_constraint/3","id":"unique_constraint/3"},{"anchor":"unsafe_validate_unique/4","id":"unsafe_validate_unique/4"},{"anchor":"update_change/3","id":"update_change/3"},{"anchor":"validate_acceptance/3","id":"validate_acceptance/3"},{"anchor":"validate_change/3","id":"validate_change/3"},{"anchor":"validate_change/4","id":"validate_change/4"},{"anchor":"validate_confirmation/3","id":"validate_confirmation/3"},{"anchor":"validate_exclusion/4","id":"validate_exclusion/4"},{"anchor":"validate_format/4","id":"validate_format/4"},{"anchor":"validate_inclusion/4","id":"validate_inclusion/4"},{"anchor":"validate_length/3","id":"validate_length/3"},{"anchor":"validate_number/3","id":"validate_number/3"},{"anchor":"validate_required/3","id":"validate_required/3"},{"anchor":"validate_subset/4","id":"validate_subset/4"},{"anchor":"validations/1","id":"validations/1"}]}],"sections":[{"anchor":"module-external-vs-internal-data","id":"External vs internal data"},{"anchor":"module-validations-and-constraints","id":"Validations and constraints"},{"anchor":"module-empty-values","id":"Empty values"},{"anchor":"module-associations-embeds-and-on-replace","id":"Associations, embeds and on replace"},{"anchor":"module-schemaless-changesets","id":"Schemaless changesets"},{"anchor":"module-the-ecto-changeset-struct","id":"The Ecto.Changeset struct"}],"title":"Ecto.Changeset"},{"group":"","id":"Ecto.Multi","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:changes/0","id":"changes/0"},{"anchor":"t:fun/1","id":"fun/1"},{"anchor":"t:merge/0","id":"merge/0"},{"anchor":"t:name/0","id":"name/0"},{"anchor":"t:run/0","id":"run/0"},{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"append/2","id":"append/2"},{"anchor":"delete/4","id":"delete/4"},{"anchor":"delete_all/4","id":"delete_all/4"},{"anchor":"error/3","id":"error/3"},{"anchor":"insert/4","id":"insert/4"},{"anchor":"insert_all/5","id":"insert_all/5"},{"anchor":"insert_or_update/4","id":"insert_or_update/4"},{"anchor":"merge/2","id":"merge/2"},{"anchor":"merge/4","id":"merge/4"},{"anchor":"new/0","id":"new/0"},{"anchor":"prepend/2","id":"prepend/2"},{"anchor":"run/3","id":"run/3"},{"anchor":"run/5","id":"run/5"},{"anchor":"to_list/1","id":"to_list/1"},{"anchor":"update/4","id":"update/4"},{"anchor":"update_all/5","id":"update_all/5"}]}],"sections":[{"anchor":"module-changesets","id":"Changesets"},{"anchor":"module-run","id":"Run"},{"anchor":"module-example","id":"Example"}],"title":"Ecto.Multi"},{"group":"","id":"Ecto.Query","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:dynamic/0","id":"dynamic/0"},{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"distinct/3","id":"distinct/3"},{"anchor":"dynamic/2","id":"dynamic/2"},{"anchor":"except/2","id":"except/2"},{"anchor":"except_all/2","id":"except_all/2"},{"anchor":"exclude/2","id":"exclude/2"},{"anchor":"first/2","id":"first/2"},{"anchor":"from/2","id":"from/2"},{"anchor":"group_by/3","id":"group_by/3"},{"anchor":"has_named_binding?/2","id":"has_named_binding?/2"},{"anchor":"having/3","id":"having/3"},{"anchor":"intersect/2","id":"intersect/2"},{"anchor":"intersect_all/2","id":"intersect_all/2"},{"anchor":"join/5","id":"join/5"},{"anchor":"last/2","id":"last/2"},{"anchor":"limit/3","id":"limit/3"},{"anchor":"lock/3","id":"lock/3"},{"anchor":"offset/3","id":"offset/3"},{"anchor":"or_having/3","id":"or_having/3"},{"anchor":"or_where/3","id":"or_where/3"},{"anchor":"order_by/3","id":"order_by/3"},{"anchor":"preload/3","id":"preload/3"},{"anchor":"put_query_prefix/2","id":"put_query_prefix/2"},{"anchor":"recursive_ctes/2","id":"recursive_ctes/2"},{"anchor":"reverse_order/1","id":"reverse_order/1"},{"anchor":"select/3","id":"select/3"},{"anchor":"select_merge/3","id":"select_merge/3"},{"anchor":"subquery/2","id":"subquery/2"},{"anchor":"union/2","id":"union/2"},{"anchor":"union_all/2","id":"union_all/2"},{"anchor":"update/3","id":"update/3"},{"anchor":"where/3","id":"where/3"},{"anchor":"windows/3","id":"windows/3"},{"anchor":"with_cte/3","id":"with_cte/3"}]}],"sections":[{"anchor":"module-query-expressions","id":"Query expressions"},{"anchor":"module-interpolation-and-casting","id":"Interpolation and casting"},{"anchor":"module-nil-comparison","id":"nil comparison"},{"anchor":"module-composition","id":"Composition"},{"anchor":"module-fragments","id":"Fragments"},{"anchor":"module-macro-api","id":"Macro API"},{"anchor":"module-query-prefix","id":"Query Prefix"}],"title":"Ecto.Query"},{"group":"","id":"Ecto.Repo","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:__adapter__/0","id":"__adapter__/0"},{"anchor":"c:aggregate/3","id":"aggregate/3"},{"anchor":"c:aggregate/4","id":"aggregate/4"},{"anchor":"c:all/2","id":"all/2"},{"anchor":"c:checkout/2","id":"checkout/2"},{"anchor":"c:config/0","id":"config/0"},{"anchor":"c:default_options/1","id":"default_options/1"},{"anchor":"c:delete/2","id":"delete/2"},{"anchor":"c:delete!/2","id":"delete!/2"},{"anchor":"c:delete_all/2","id":"delete_all/2"},{"anchor":"c:exists?/2","id":"exists?/2"},{"anchor":"c:get/3","id":"get/3"},{"anchor":"c:get!/3","id":"get!/3"},{"anchor":"c:get_by/3","id":"get_by/3"},{"anchor":"c:get_by!/3","id":"get_by!/3"},{"anchor":"c:get_dynamic_repo/0","id":"get_dynamic_repo/0"},{"anchor":"c:in_transaction?/0","id":"in_transaction?/0"},{"anchor":"c:init/2","id":"init/2"},{"anchor":"c:insert/2","id":"insert/2"},{"anchor":"c:insert!/2","id":"insert!/2"},{"anchor":"c:insert_all/3","id":"insert_all/3"},{"anchor":"c:insert_or_update/2","id":"insert_or_update/2"},{"anchor":"c:insert_or_update!/2","id":"insert_or_update!/2"},{"anchor":"c:load/2","id":"load/2"},{"anchor":"c:one/2","id":"one/2"},{"anchor":"c:one!/2","id":"one!/2"},{"anchor":"c:preload/3","id":"preload/3"},{"anchor":"c:prepare_query/3","id":"prepare_query/3"},{"anchor":"c:put_dynamic_repo/1","id":"put_dynamic_repo/1"},{"anchor":"c:rollback/1","id":"rollback/1"},{"anchor":"c:start_link/1","id":"start_link/1"},{"anchor":"c:stop/1","id":"stop/1"},{"anchor":"c:stream/2","id":"stream/2"},{"anchor":"c:transaction/2","id":"transaction/2"},{"anchor":"c:update/2","id":"update/2"},{"anchor":"c:update!/2","id":"update!/2"},{"anchor":"c:update_all/3","id":"update_all/3"}]}],"sections":[{"anchor":"module-urls","id":"URLs"},{"anchor":"module-shared-options","id":"Shared options"},{"anchor":"module-telemetry-events","id":"Telemetry events"},{"anchor":"module-read-only-repositories","id":"Read-only repositories"}],"title":"Ecto.Repo"},{"group":"","id":"Ecto.Schema","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:belongs_to/1","id":"belongs_to/1"},{"anchor":"t:embedded_schema/0","id":"embedded_schema/0"},{"anchor":"t:has_many/1","id":"has_many/1"},{"anchor":"t:has_one/1","id":"has_one/1"},{"anchor":"t:many_to_many/1","id":"many_to_many/1"},{"anchor":"t:prefix/0","id":"prefix/0"},{"anchor":"t:schema/0","id":"schema/0"},{"anchor":"t:source/0","id":"source/0"},{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"belongs_to/3","id":"belongs_to/3"},{"anchor":"embedded_schema/1","id":"embedded_schema/1"},{"anchor":"embeds_many/3","id":"embeds_many/3"},{"anchor":"embeds_many/4","id":"embeds_many/4"},{"anchor":"embeds_one/3","id":"embeds_one/3"},{"anchor":"embeds_one/4","id":"embeds_one/4"},{"anchor":"field/3","id":"field/3"},{"anchor":"has_many/3","id":"has_many/3"},{"anchor":"has_one/3","id":"has_one/3"},{"anchor":"many_to_many/3","id":"many_to_many/3"},{"anchor":"schema/2","id":"schema/2"},{"anchor":"timestamps/1","id":"timestamps/1"}]}],"sections":[{"anchor":"module-example","id":"Example"},{"anchor":"module-redacting-fields","id":"Redacting fields"},{"anchor":"module-schema-attributes","id":"Schema attributes"},{"anchor":"module-primary-keys","id":"Primary keys"},{"anchor":"module-types-and-casting","id":"Types and casting"},{"anchor":"module-reflection","id":"Reflection"},{"anchor":"module-working-with-typespecs","id":"Working with typespecs"}],"title":"Ecto.Schema"},{"group":"","id":"Ecto.Schema.Metadata","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:context/0","id":"context/0"},{"anchor":"t:state/0","id":"state/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[{"anchor":"module-state","id":"State"},{"anchor":"module-source","id":"Source"},{"anchor":"module-prefix","id":"Prefix"},{"anchor":"module-context","id":"Context"},{"anchor":"module-schema","id":"Schema"}],"title":"Ecto.Schema.Metadata"},{"group":"","id":"Mix.Ecto","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"ensure_implements/3","id":"ensure_implements/3"},{"anchor":"ensure_repo/2","id":"ensure_repo/2"},{"anchor":"no_umbrella!/1","id":"no_umbrella!/1"},{"anchor":"open?/1","id":"open?/1"},{"anchor":"parse_repo/1","id":"parse_repo/1"}]}],"sections":[],"title":"Mix.Ecto"},{"group":"Types","id":"Ecto.Enum","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"cast/2","id":"cast/2"},{"anchor":"dump/3","id":"dump/3"},{"anchor":"embed_as/2","id":"embed_as/2"},{"anchor":"equal?/3","id":"equal?/3"},{"anchor":"init/1","id":"init/1"},{"anchor":"load/3","id":"load/3"},{"anchor":"type/1","id":"type/1"}]}],"sections":[],"title":"Ecto.Enum"},{"group":"Types","id":"Ecto.ParameterizedType","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:opts/0","id":"opts/0"},{"anchor":"t:params/0","id":"params/0"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:cast/2","id":"cast/2"},{"anchor":"c:dump/3","id":"dump/3"},{"anchor":"c:embed_as/2","id":"embed_as/2"},{"anchor":"c:equal?/3","id":"equal?/3"},{"anchor":"c:init/1","id":"init/1"},{"anchor":"c:load/3","id":"load/3"},{"anchor":"c:type/1","id":"type/1"}]}],"sections":[{"anchor":"module-examples","id":"Examples"}],"title":"Ecto.ParameterizedType"},{"group":"Types","id":"Ecto.Type","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:base/0","id":"base/0"},{"anchor":"t:composite/0","id":"composite/0"},{"anchor":"t:custom/0","id":"custom/0"},{"anchor":"t:primitive/0","id":"primitive/0"},{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"base?/1","id":"base?/1"},{"anchor":"cast/2","id":"cast/2"},{"anchor":"composite?/1","id":"composite?/1"},{"anchor":"dump/3","id":"dump/3"},{"anchor":"embed_as/2","id":"embed_as/2"},{"anchor":"embedded_dump/3","id":"embedded_dump/3"},{"anchor":"embedded_load/3","id":"embedded_load/3"},{"anchor":"equal?/3","id":"equal?/3"},{"anchor":"load/3","id":"load/3"},{"anchor":"match?/2","id":"match?/2"},{"anchor":"primitive?/1","id":"primitive?/1"},{"anchor":"type/1","id":"type/1"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:cast/1","id":"cast/1"},{"anchor":"c:dump/1","id":"dump/1"},{"anchor":"c:embed_as/1","id":"embed_as/1"},{"anchor":"c:equal?/2","id":"equal?/2"},{"anchor":"c:load/1","id":"load/1"},{"anchor":"c:type/0","id":"type/0"}]}],"sections":[{"anchor":"module-example","id":"Example"}],"title":"Ecto.Type"},{"group":"Types","id":"Ecto.UUID","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:raw/0","id":"raw/0"},{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"bingenerate/0","id":"bingenerate/0"},{"anchor":"cast/1","id":"cast/1"},{"anchor":"cast!/1","id":"cast!/1"},{"anchor":"dump/1","id":"dump/1"},{"anchor":"embed_as/1","id":"embed_as/1"},{"anchor":"equal?/2","id":"equal?/2"},{"anchor":"generate/0","id":"generate/0"},{"anchor":"load/1","id":"load/1"}]}],"sections":[],"title":"Ecto.UUID"},{"group":"Query APIs","id":"Ecto.Query.API","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"!=/2","id":"!=/2"},{"anchor":"*/2","id":"*/2"},{"anchor":"+/2","id":"+/2"},{"anchor":"-/2","id":"-/2"},{"anchor":"//2","id":"//2"},{"anchor":"%3C/2","id":"&lt;/2"},{"anchor":"%3C=/2","id":"&lt;=/2"},{"anchor":"==/2","id":"==/2"},{"anchor":"%3E/2","id":"&gt;/2"},{"anchor":"%3E=/2","id":"&gt;=/2"},{"anchor":"ago/2","id":"ago/2"},{"anchor":"and/2","id":"and/2"},{"anchor":"as/1","id":"as/1"},{"anchor":"avg/1","id":"avg/1"},{"anchor":"coalesce/2","id":"coalesce/2"},{"anchor":"count/0","id":"count/0"},{"anchor":"count/1","id":"count/1"},{"anchor":"count/2","id":"count/2"},{"anchor":"date_add/3","id":"date_add/3"},{"anchor":"datetime_add/3","id":"datetime_add/3"},{"anchor":"field/2","id":"field/2"},{"anchor":"filter/2","id":"filter/2"},{"anchor":"fragment/1","id":"fragment/1"},{"anchor":"from_now/2","id":"from_now/2"},{"anchor":"ilike/2","id":"ilike/2"},{"anchor":"in/2","id":"in/2"},{"anchor":"is_nil/1","id":"is_nil/1"},{"anchor":"json_extract_path/2","id":"json_extract_path/2"},{"anchor":"like/2","id":"like/2"},{"anchor":"map/2","id":"map/2"},{"anchor":"max/1","id":"max/1"},{"anchor":"merge/2","id":"merge/2"},{"anchor":"min/1","id":"min/1"},{"anchor":"not/1","id":"not/1"},{"anchor":"or/2","id":"or/2"},{"anchor":"parent_as/1","id":"parent_as/1"},{"anchor":"struct/2","id":"struct/2"},{"anchor":"sum/1","id":"sum/1"},{"anchor":"type/2","id":"type/2"}]}],"sections":[{"anchor":"module-intervals","id":"Intervals"},{"anchor":"module-window-api","id":"Window API"},{"anchor":"module-about-the-arithmetic-operators","id":"About the arithmetic operators"}],"title":"Ecto.Query.API"},{"group":"Query APIs","id":"Ecto.Query.WindowAPI","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"avg/1","id":"avg/1"},{"anchor":"count/0","id":"count/0"},{"anchor":"count/1","id":"count/1"},{"anchor":"cume_dist/0","id":"cume_dist/0"},{"anchor":"dense_rank/0","id":"dense_rank/0"},{"anchor":"filter/2","id":"filter/2"},{"anchor":"first_value/1","id":"first_value/1"},{"anchor":"lag/3","id":"lag/3"},{"anchor":"last_value/1","id":"last_value/1"},{"anchor":"lead/3","id":"lead/3"},{"anchor":"max/1","id":"max/1"},{"anchor":"min/1","id":"min/1"},{"anchor":"nth_value/2","id":"nth_value/2"},{"anchor":"ntile/1","id":"ntile/1"},{"anchor":"percent_rank/0","id":"percent_rank/0"},{"anchor":"rank/0","id":"rank/0"},{"anchor":"row_number/0","id":"row_number/0"},{"anchor":"sum/1","id":"sum/1"}]}],"sections":[],"title":"Ecto.Query.WindowAPI"},{"group":"Query APIs","id":"Ecto.Queryable","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"to_query/1","id":"to_query/1"}]}],"sections":[],"title":"Ecto.Queryable"},{"group":"Query APIs","id":"Ecto.SubQuery","sections":[],"title":"Ecto.SubQuery"},{"group":"Adapter specification","id":"Ecto.Adapter","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:adapter_meta/0","id":"adapter_meta/0"},{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"lookup_meta/1","id":"lookup_meta/1"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:__before_compile__/1","id":"__before_compile__/1"},{"anchor":"c:checkout/3","id":"checkout/3"},{"anchor":"c:dumpers/2","id":"dumpers/2"},{"anchor":"c:ensure_all_started/2","id":"ensure_all_started/2"},{"anchor":"c:init/1","id":"init/1"},{"anchor":"c:loaders/2","id":"loaders/2"}]}],"sections":[],"title":"Ecto.Adapter"},{"group":"Adapter specification","id":"Ecto.Adapter.Queryable","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:adapter_meta/0","id":"adapter_meta/0"},{"anchor":"t:cached/0","id":"cached/0"},{"anchor":"t:options/0","id":"options/0"},{"anchor":"t:prepared/0","id":"prepared/0"},{"anchor":"t:query_cache/0","id":"query_cache/0"},{"anchor":"t:query_meta/0","id":"query_meta/0"},{"anchor":"t:selected/0","id":"selected/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"plan_query/3","id":"plan_query/3"},{"anchor":"prepare_query/3","id":"prepare_query/3"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:execute/5","id":"execute/5"},{"anchor":"c:prepare/2","id":"prepare/2"},{"anchor":"c:stream/5","id":"stream/5"}]}],"sections":[],"title":"Ecto.Adapter.Queryable"},{"group":"Adapter specification","id":"Ecto.Adapter.Schema","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:adapter_meta/0","id":"adapter_meta/0"},{"anchor":"t:constraints/0","id":"constraints/0"},{"anchor":"t:fields/0","id":"fields/0"},{"anchor":"t:filters/0","id":"filters/0"},{"anchor":"t:on_conflict/0","id":"on_conflict/0"},{"anchor":"t:options/0","id":"options/0"},{"anchor":"t:returning/0","id":"returning/0"},{"anchor":"t:schema_meta/0","id":"schema_meta/0"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:autogenerate/1","id":"autogenerate/1"},{"anchor":"c:delete/4","id":"delete/4"},{"anchor":"c:insert/6","id":"insert/6"},{"anchor":"c:insert_all/7","id":"insert_all/7"},{"anchor":"c:update/6","id":"update/6"}]}],"sections":[],"title":"Ecto.Adapter.Schema"},{"group":"Adapter specification","id":"Ecto.Adapter.Storage","nodeGroups":[{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:storage_down/1","id":"storage_down/1"},{"anchor":"c:storage_status/1","id":"storage_status/1"},{"anchor":"c:storage_up/1","id":"storage_up/1"}]}],"sections":[],"title":"Ecto.Adapter.Storage"},{"group":"Adapter specification","id":"Ecto.Adapter.Transaction","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:adapter_meta/0","id":"adapter_meta/0"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:in_transaction?/1","id":"in_transaction?/1"},{"anchor":"c:rollback/2","id":"rollback/2"},{"anchor":"c:transaction/3","id":"transaction/3"}]}],"sections":[],"title":"Ecto.Adapter.Transaction"},{"group":"Association structs","id":"Ecto.Association.BelongsTo","sections":[],"title":"Ecto.Association.BelongsTo"},{"group":"Association structs","id":"Ecto.Association.Has","sections":[],"title":"Ecto.Association.Has"},{"group":"Association structs","id":"Ecto.Association.HasThrough","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"on_repo_change/5","id":"on_repo_change/5"}]}],"sections":[],"title":"Ecto.Association.HasThrough"},{"group":"Association structs","id":"Ecto.Association.ManyToMany","sections":[],"title":"Ecto.Association.ManyToMany"},{"group":"Association structs","id":"Ecto.Association.NotLoaded","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Ecto.Association.NotLoaded"},{"group":"Exceptions","id":"Ecto.CastError","sections":[],"title":"Ecto.CastError"},{"group":"Exceptions","id":"Ecto.ChangeError","sections":[],"title":"Ecto.ChangeError"},{"group":"Exceptions","id":"Ecto.ConstraintError","sections":[],"title":"Ecto.ConstraintError"},{"group":"Exceptions","id":"Ecto.InvalidChangesetError","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"message/1","id":"message/1"}]}],"sections":[],"title":"Ecto.InvalidChangesetError"},{"group":"Exceptions","id":"Ecto.InvalidURLError","sections":[],"title":"Ecto.InvalidURLError"},{"group":"Exceptions","id":"Ecto.MigrationError","sections":[],"title":"Ecto.MigrationError"},{"group":"Exceptions","id":"Ecto.MultiplePrimaryKeyError","sections":[],"title":"Ecto.MultiplePrimaryKeyError"},{"group":"Exceptions","id":"Ecto.MultipleResultsError","sections":[],"title":"Ecto.MultipleResultsError"},{"group":"Exceptions","id":"Ecto.NoPrimaryKeyFieldError","sections":[],"title":"Ecto.NoPrimaryKeyFieldError"},{"group":"Exceptions","id":"Ecto.NoPrimaryKeyValueError","sections":[],"title":"Ecto.NoPrimaryKeyValueError"},{"group":"Exceptions","id":"Ecto.NoResultsError","sections":[],"title":"Ecto.NoResultsError"},{"group":"Exceptions","id":"Ecto.Query.CastError","sections":[],"title":"Ecto.Query.CastError"},{"group":"Exceptions","id":"Ecto.Query.CompileError","sections":[],"title":"Ecto.Query.CompileError"},{"group":"Exceptions","id":"Ecto.QueryError","sections":[],"title":"Ecto.QueryError"},{"group":"Exceptions","id":"Ecto.StaleEntryError","sections":[],"title":"Ecto.StaleEntryError"},{"group":"Exceptions","id":"Ecto.SubQueryError","sections":[],"title":"Ecto.SubQueryError"}],"tasks":[{"group":"","id":"Mix.Tasks.Ecto","sections":[],"title":"mix ecto"},{"group":"","id":"Mix.Tasks.Ecto.Create","sections":[{"anchor":"module-examples","id":"Examples"},{"anchor":"module-command-line-options","id":"Command line options"}],"title":"mix ecto.create"},{"group":"","id":"Mix.Tasks.Ecto.Drop","sections":[{"anchor":"module-examples","id":"Examples"},{"anchor":"module-command-line-options","id":"Command line options"}],"title":"mix ecto.drop"},{"group":"","id":"Mix.Tasks.Ecto.Gen.Repo","sections":[{"anchor":"module-examples","id":"Examples"},{"anchor":"module-command-line-options","id":"Command line options"}],"title":"mix ecto.gen.repo"}]}